#include<iostream>
using namespace std;
int n,q,x[200000];
void unos()
{
    cin>>n>>q;
    for(int i=1;i<=n;i++)
        cin>>x[i];
}
int upit(int a, int b)
{
    return a&b;
}
void program()
{
    int i,l,r;
    for(i=0;i<q;i++)
    {
        cin>>l>>r;
        cout<<upit(x[l],x[r]);
    }
}
int main()
{
    unos();
    program();
}